/*
DL2 Monitor: ./pa/tcp.h
Copyright (C) 2002, Rolf Jger, Ulm (Germany)

See the file README for information on usage and redistribution
of this source code file, and for a DISCLAIMER OF ALL WARRANTIES.
*/

/*----------------------------------------------------------------------------
 * Datalink Monitor (tcp): Packet Type tcp (local)
 * creates the Pa_Packet object pa_tcp: see pa.h for details. 
 *
 * Author: Rolf Jger,Ulm
 *----------------------------------------------------------------------------
 * YYYYMMDD  History
 * 20020410  attention to reserved verbose flags. 
 * 20020330  created from scratch
 * $Id: tcp.h,v 1.4 2002/04/14 21:09:42 dv Exp $
 *----------------------------------------------------------------------------
*/
# ifndef __TCP_H__
# define __TCP_H__
# include "pa/pa.h"

static Pa_Config pa_tcp_field[] = {
  {"source-port","SP",0}, 
  {"destination-port","DP",1}, 
  {"sequence-number","SN",2}, 
  {"acknowledgment-number","AN",3}, 
  {"header-length","HL",4}, 
  {"flags","FLG",5}, 
  {"window","WD",6}, 
  {"checksum","CS",7}, 
  {"urgent-pointer","UP",8}, 
  {"options","O",9}, 
  {"data","FD",10}, 
  {NULL,NULL,-1}
};
const Pa_Packet pa_tcp = {"tcp",pa_tcp_field};

# define TCP_Msource_port		0x00000001
# define TCP_Mdestination_port		0x00000002
# define TCP_Msequence_number		0x00000004
# define TCP_Macknowledgment_number	0x00000008
# define TCP_Mheader_length		0x00000010
# define TCP_Mflags			0x00000020
# define TCP_Mwindow			0x00000040
# define TCP_Mchecksum			0x00000080
# define TCP_Murgent_pointer		0x00000100
# define TCP_Moptions			0x00000200
# define TCP_Mdata			0x00000400
# define TCP_Mdefault			PA_VMdefault
# define TCP_Mpacket_length		PA_VMpacket_length

# define TCP_F(i)			pa_tcp_field[i].oname
# define TCP_Fsource_port		TCP_F(0)
# define TCP_Fdestination_port		TCP_F(1)
# define TCP_Fsequence_number		TCP_F(2)
# define TCP_Facknowledgment_number	TCP_F(3)
# define TCP_Fheader_length		TCP_F(4)
# define TCP_Fflags			TCP_F(5)
# define TCP_Fwindow			TCP_F(6)
# define TCP_Fchecksum			TCP_F(7)
# define TCP_Furgent_pointer		TCP_F(8)
# define TCP_Foptions			TCP_F(9)
# define TCP_Fdata			TCP_F(10)
# define TCP_Fpacket_length		PA_VFpacket_length

# endif /*__TCP_H__*/
